【LeetCode】300 Longest Increasing Subsequence

来源:互联网 发布:灵格斯 for mac 编辑:程序博客网 时间:2024/05/16 10:18
Longest Increasing Subsequence
Total Accepted: 8193 Total Submissions: 26128 Difficulty: Medium
Given an unsorted array of integers, find the length of longest increasing subsequence.
For example,
Given [10, 9, 2, 5, 3, 7, 101, 18],
The longest increasing subsequence is [2, 3, 7, 101], therefore the length is 4. 
Note that there may be more than one LIS combination, it is only necessary for you to return the length.

Your algorithm should run in O(n2) complexity.

Follow up: Could you improve it to O(n log n) time complexity?

Credits:
Special thanks to @pbrother for adding this problem and creating all test cases.
Subscribe to see which companies asked this question

【解题思路】
LIS,O(n2)以及O(nlogn)两种解法,很经典。

Java AC O(n2)

public class Solution {    public int lengthOfLIS(int[] nums) {        if(nums == null || nums.length == 0){            return 0;        }        int len = nums.length;        int maxLen = 1;        int dp[] = new int[len+1];        for (int i = 0; i < len; i++) {            dp[i] = 1;            for (int j = 0; j < i; j++) {                if (nums[i] > nums[j]){                    dp[i] = dp[j] + 1 > dp[i] ? dp[j] + 1 : dp[i];                    maxLen = dp[i] > maxLen ? dp[i] : maxLen;                }            }        }        return maxLen;    }}

Java AC O(nlogn)

public class Solution {    public int lengthOfLIS(int[] nums) {        if (nums == null || nums.length == 0) {            return 0;        }        int len = nums.length;        int dp[] = new int[len + 1];        dp[0] = nums[0];        int maxLen = 0;        for (int i = 1; i < len; i++) {            if (nums[i] > dp[maxLen]) {                dp[++maxLen] = nums[i];            } else {                int pos = binarySearch(dp, 0, maxLen, nums[i]);                dp[pos] = nums[i];            }        }        return maxLen + 1;    }    private int binarySearch(int[] dp, int left, int right, int num) {        while (left < right) {            int mid = left + (right - left) / 2;            if (dp[mid] == num) {                return mid;            }            if (dp[mid] > num) {                right -= 1;            } else {                left += 1;            }        }        return left;    }}



0 0
原创粉丝点击